<?php

namespace RxConnexionBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Form\FormEvent;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;
use Doctrine\Common\Persistence\ObjectManager;

class MedicationForm extends AbstractType
{

    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('id', HiddenType::class)
            ->add('code', TextType::class, array(
                'label' => 'Code',
                'required' => false
            ))
            ->add('description', TextType::class, array(
                'label' => 'Description',
                'label_attr' => array(
                    'class' => 'required middle'
                ),
                'required' => true
            ))
            ->add('medication_type', HiddenType::class)
            ->addEventListener(FormEvents::PRE_SET_DATA, function(FormEvent $event) {
                $form = $event->getForm();
                $data = $event->getData();
                $medicationType = $data->getMedicationType();
                
                $form
                ->add('medication_type_desc', TextType::class, array(
                    'label' => 'Type',
                    'label_attr' => array(
                        'class' => 'required middle'
                    ),
                    'required' => true,
                    'mapped' => false,
                    'data' => $medicationType ? $medicationType->getDescription() : ''
                ));  
            });
        $builder->get('medication_type')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:MedicationTypeEntity', false));
    }

    public function getBlockPrefix()
    {
        return 'medication';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\MedicationEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'medicationEntity_intention',
            'action'          => 'n'
        ));
    }
}